<h1 id="using-ace-with-javascript-frameworks">Using ACE with JavaScript frameworks</h1>
<p>ACE makes use of custom elements which makes it easy to use with nost JavaScript frameworks. Below are intructions for how to use ACE with React, Angular and Vue.</p>
<h2 id="ace-with-react">ACE with React</h2>
<p>The following examples show how ACE components can be used with React. More general information about how to use custom elements with React can be found in the <a href="https://reactjs.org/docs/web-components.html">React web components guide</a>.</p>
<p>These examples demonstrate how to use an ACE Accordion, pass data to it from a parent component via <code>props</code>, use <code>useEffect</code> in the parent to listen for a custom event dispatched by Accordion, and interact with Accordion from the parent using a custom event.</p>
<h3 id="react-without-typescript">React without TypeScript</h3>
<p>Starting with a fresh React project that does not use TypeScript, created using <code>npx create-react-app</code>:</p>
<ol>
<li>Install ACE:</li>
</ol>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<ol start="2">
<li>Replace the contents of <em><strong>src/App.js</strong></em> with:</li>
</ol>
<pre><code class="language-jsx">import {useEffect, useState} from 'react';
import {ATTRS, EVENTS} from '@potato/ace/components/accordion/accordion';
import {Accordion} from './Accordion';
import './App.css';

const accordionContent = [
  {
    content: 'Panel 1 content',
    trigger: 'Panel 1 trigger',
  },
  {
    content: 'Panel 2 content',
    trigger: 'Panel 2 trigger',
  }
];

function App() {
  const ACCORDION_ID = 'ace-accordion';
  const [disableCollapseAllBtn, setDisableCollapseAllBtn] = useState(true);

  // Accordion &quot;Panel visibility changed&quot; custom event handler to disable &quot;Collapse all&quot; button when all panels are collapsed
  const handleAccordionPanelStateChange = () =&gt; {
    const panelsCollapsed = document.querySelectorAll(`[${ATTRS.PANEL_VISIBLE}]`).length === 0;
    setDisableCollapseAllBtn(panelsCollapsed);
  }

  // useEffect used to add Accordion's &quot;Panel visibility changed&quot; custom event listener
  useEffect(() =&gt; {
    window.addEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, handleAccordionPanelStateChange);
    return () =&gt; window.removeEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, handleAccordionPanelStateChange);
  }, []);

  // Collapse Accordion's panels by dispatching its &quot;Hide panels&quot; custom event
  const collapseAll = () =&gt; window.dispatchEvent(new CustomEvent(
    EVENTS.IN.HIDE_ALL_PANELS,
    {'detail': {'id': ACCORDION_ID}},
  ));

  return (
    &lt;&gt;
      &lt;Accordion content={accordionContent} id={ACCORDION_ID} /&gt;
      &lt;button	disabled={disableCollapseAllBtn} onClick={collapseAll} &gt;
        Collapse all
      &lt;/button&gt;
    &lt;/&gt;
  );
}

export default App;
</code></pre>
<ol start="3">
<li>Replace the contents of <em><strong>src/App.css</strong></em> with:</li>
</ol>
<pre><code class="language-css">@import '~@potato/ace/components/accordion/ace-accordion.css';
</code></pre>
<ol start="4">
<li>Add a file <em><strong>src/Accordion.jsx</strong></em> with the following content:</li>
</ol>
<pre><code class="language-jsx">import React from 'react';
import '@potato/ace/components/accordion/accordion';

export const Accordion = ({content, id}) =&gt; {
  return (
    &lt;ace-accordion id={id}&gt;
      {content.map((panel, index) =&gt; {
        return &lt;React.Fragment key={index}&gt;
          &lt;h3&gt;
            &lt;button&gt;{panel.trigger}&lt;/button&gt;
          &lt;/h3&gt;
          &lt;div&gt;
            &lt;p&gt;{panel.content}&lt;/p&gt;
          &lt;/div&gt;
        &lt;/React.Fragment&gt;
      })}
    &lt;/ace-accordion&gt;
  );
};
</code></pre>
<h4 id="react-with-typescript">React with TypeScript</h4>
<p>Starting with a fresh React TypeScript project created using <code>npx create-react-app</code>:</p>
<ol>
<li>Install ACE:</li>
</ol>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<ol start="2">
<li>Replace the contents of <em><strong>src/App.tsx</strong></em> with:</li>
</ol>
<pre><code class="language-jsx">import {useEffect, useState} from 'react';
import {ATTRS, EVENTS} from '@potato/ace/components/accordion/accordion';
import {Accordion} from './Accordion';
import './App.css';

export interface AccordionContent {
  content: string;
  trigger: string;
}

const accordionContent: AccordionContent[] = [
  {
    content: 'Panel 1 content',
    trigger: 'Panel 1 trigger',
  },
  {
    content: 'Panel 2 content',
    trigger: 'Panel 2 trigger',
  }
];

function App() {
  const ACCORDION_ID = 'ace-accordion';
  const [disableCollapseAllBtn, setDisableCollapseAllBtn] = useState(true);

  // Accordion &quot;Panel visibility changed&quot; custom event handler to disable &quot;Collapse all&quot; button when all panels are collapsed
  const handleAccordionPanelStateChange = () =&gt; {
    const panelsCollapsed = document.querySelectorAll(`[${ATTRS.PANEL_VISIBLE}]`).length === 0;
    setDisableCollapseAllBtn(panelsCollapsed);
  }

  // useEffect used to add Accordion's &quot;Panel visibility changed&quot; custom event listener
  useEffect(() =&gt; {
    window.addEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, handleAccordionPanelStateChange);
    return () =&gt; window.removeEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, handleAccordionPanelStateChange);
  }, []);

  // Collapse Accordion's panels using its &quot;hide panels&quot; custom event
  const collapseAll = () =&gt; window.dispatchEvent(new CustomEvent(
    EVENTS.IN.HIDE_ALL_PANELS,
    {'detail': {'id': ACCORDION_ID}},
  ));

  return (
    &lt;&gt;
      &lt;Accordion content={accordionContent} id={ACCORDION_ID} /&gt;
      &lt;button	disabled={disableCollapseAllBtn} onClick={collapseAll} &gt;
        Collapse all
      &lt;/button&gt;
    &lt;/&gt;
  );
}

export default App;
</code></pre>
<ol start="3">
<li>Replace the contents of <em><strong>src/App.css</strong></em> with:</li>
</ol>
<pre><code class="language-css">@import '~@potato/ace/components/accordion/ace-accordion.css';
</code></pre>
<ol start="4">
<li>Add a file <em><strong>src/Accordion.tsx</strong></em> with:</li>
</ol>
<pre><code class="language-tsx">import React from 'react';
import {AccordionContent} from './App';
import '@potato/ace/components/accordion/accordion';

interface Props {
  content: Array&lt;AccordionContent&gt;,
  id: string,
}

export const Accordion = ({content, id}: Props) =&gt; {
  return (
    &lt;ace-accordion id={id}&gt;
      {content.map((panel: AccordionContent, index: number) =&gt; {
        return &lt;React.Fragment key={index}&gt;
          &lt;h3&gt;
            &lt;button&gt;{panel.trigger}&lt;/button&gt;
          &lt;/h3&gt;
          &lt;div&gt;
            &lt;p&gt;{panel.content}&lt;/p&gt;
          &lt;/div&gt;
        &lt;/React.Fragment&gt;
      })}
    &lt;/ace-accordion&gt;
  );
};

declare global {
  namespace JSX {
    interface IntrinsicElements {
      'ace-accordion': any;
    }
  }
}
</code></pre>
<h2 id="ace-with-angular">ACE with Angular</h2>
<p>The following examples shows how ACE components can be used with Angular.</p>
<p>These examples demonstrate how to use an ACE Accordion, pass data to it from a parent component via <code>@Input</code>, use <code>@HostListener</code> in the parent to listen for a custom event dispatched by Accordion, and interact with Accordion from the parent using a custom event.</p>
<p>Starting with a fresh Angular project created using Angular CLI command <code>ng new</code>:</p>
<ol>
<li>Install ACE:</li>
</ol>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<ol start="2">
<li>Add the following to the <code>&quot;files&quot;</code> property in <em><strong>tsconfig.app.json</strong></em> :</li>
</ol>
<pre><code class="language-json">&quot;./node_modules/@potato/ace/components/accordion/accordion.ts&quot;
</code></pre>
<ol start="3">
<li>Replace the contents of <em><strong>src/app/app.module.ts</strong></em> with:</li>
</ol>
<pre><code class="language-ts">import { NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';

import { AppComponent } from './app.component';
import { AccordionComponent } from './accordion/accordion.component';

@NgModule({
  declarations: [
    AccordionComponent,
    AppComponent
  ],
  imports: [
    BrowserModule
  ],
  schemas: [CUSTOM_ELEMENTS_SCHEMA],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
</code></pre>
<ol start="4">
<li>Replace the contents of <em><strong>src/app/app.component.ts</strong></em> with:</li>
</ol>
<pre><code class="language-ts">import { Component, HostListener } from '@angular/core';
import { AccordionContent } from './accordion/accordion.component';
import { ATTRS, EVENTS } from '@potato/ace/components/accordion/accordion';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  accordionContent: Array&lt;AccordionContent&gt; = [
    {
      content: 'Panel 1 content',
      trigger: 'Panel 1 trigger',
    },
    {
      content: 'Panel 2 content',
      trigger: 'Panel 2 trigger',
    },
  ];
  accordionId = 'ace-accordion';
  panelsCollapsed = true;

  // Collapse Accordion's panels using it's &quot;hide panels&quot; custom event
  collapseAll() {
    window.dispatchEvent(new CustomEvent(
      EVENTS.IN.HIDE_ALL_PANELS,
      {'detail': {'id': this.accordionId}},
    ));
  }

  // @HostListener used to add Accordion &quot;Panel visibility changed&quot; event listener
  @HostListener(`window:${EVENTS.OUT.PANEL_VISIBILITY_CHANGED}`, ['$event.detail'])
  onPanelChange(): void {
    this.panelsCollapsed = document.querySelectorAll(`[${ATTRS.PANEL_VISIBLE}]`).length === 0;
  }
}
</code></pre>
<ol start="5">
<li>Replace the contents of <em><strong>src/app/app.component.html</strong></em> with:</li>
</ol>
<pre><code class="language-html">&lt;app-accordion [content]=&quot;accordionContent&quot; [accordionId]=&quot;accordionId&quot;&gt;&lt;/app-accordion&gt;
&lt;button [disabled]=&quot;panelsCollapsed&quot; (click)=&quot;collapseAll()&quot;&gt;
  Collapse all
&lt;/button&gt;
</code></pre>
<ol start="6">
<li>Generate a new component called <code>accordion</code>:</li>
</ol>
<pre><code class="language-bash">ng g c accordion
</code></pre>
<ol start="7">
<li>Replace the contents of <em><strong>src/app/accordion/accordion.component.html</strong></em> with:</li>
</ol>
<pre><code class="language-html">&lt;ace-accordion [id]=&quot;accordionId&quot;&gt;
  &lt;ng-container *ngFor=&quot;let panel of content&quot;&gt;
    &lt;h3&gt;
      &lt;button&gt;{{panel.trigger}}&lt;/button&gt;
    &lt;/h3&gt;
    &lt;div&gt;
      &lt;p&gt;{{panel.content}}&lt;/p&gt;
    &lt;/div&gt;
  &lt;/ng-container&gt;
&lt;/ace-accordion&gt;
</code></pre>
<ol start="8">
<li>Replace the contents of <em><strong>src/app/accordion/accordion.component.ts</strong></em> with:</li>
</ol>
<pre><code class="language-ts">import { Component, Input } from '@angular/core';
import '@potato/ace/components/accordion/accordion';

export interface AccordionContent {
  content: string;
  trigger: string;
}

@Component({
  selector: 'app-accordion',
  templateUrl: './accordion.component.html',
  styleUrls: ['./accordion.component.css']
})
export class AccordionComponent {
  @Input()
  accordionId: String = '';
  
  @Input()
  content: Array&lt;AccordionContent&gt; = [];
}
</code></pre>
<ol start="9">
<li>Replace the contents of <em><strong>src/app/accordion/accordion.component.css</strong></em> with:</li>
</ol>
<pre><code class="language-css">@import '~@potato/ace/components/accordion/ace-accordion.css';
</code></pre>
<h3 id="importing-ace-javascript-component-files">Importing ACE JavaScript component files</h3>
<p>If ACE component TypeScript files cause TypeScript compilation errors due to a difference in compiler options between ACE and the project, the recommended approach is to use the provided ACE component JavaScript file.</p>
<p>This can be achieved by adding <code>&quot;types&quot;: [&quot;node&quot;]</code> to the <code>&quot;compilerOptions&quot;</code> property in <em><strong>tsconfig.app.json</strong></em> and using <code>require('@potato/ace/components/&lt;component&gt;/&lt;component&gt;.js')</code> to import the ACE component's JavaScript file, where <code>&lt;component&gt;</code> is the component name. Exported properties, e.g. <code>ATTRS</code>, can also be imported using <code>const { ATTRS } = require('@potato/ace/components/&lt;component&gt;/&lt;component&gt;.js')</code>.</p>
<p>To use the Accordion JavaScript file in the example above first follow the example and then:</p>
<ol>
<li>Replace contents of <em><strong>tsconfig.app.json</strong></em> with:</li>
</ol>
<pre><code class="language-json">{
  &quot;extends&quot;: &quot;./tsconfig.json&quot;,
  &quot;compilerOptions&quot;: {
    &quot;outDir&quot;: &quot;./out-tsc/app&quot;,
    &quot;types&quot;: [&quot;node&quot;]
  },
  &quot;files&quot;: [
    &quot;src/main.ts&quot;,
    &quot;src/polyfills.ts&quot;
  ],
  &quot;include&quot;: [
    &quot;src/**/*.d.ts&quot;
  ]
}
</code></pre>
<ol start="2">
<li>In <em><strong>src/app/app.component.ts</strong></em> replace:</li>
</ol>
<pre><code class="language-ts">import {ATTRS, EVENTS} from '@potato/ace/components/accordion/accordion';
</code></pre>
<p>with</p>
<pre><code class="language-ts">const { ATTRS, EVENTS } = require('@potato/ace/components/accordion/accordion.js');
</code></pre>
<p>and replace:</p>
<pre><code class="language-ts">@HostListener(`window:${EVENTS.OUT.PANEL_VISIBILITY_CHANGED}`, ['$event.detail'])
</code></pre>
<p>with:</p>
<pre><code class="language-ts">@HostListener('window:ace-accordion-panel-visibility-changed', ['$event.detail'])
</code></pre>
<ol start="3">
<li>In <em><strong>src/app/accordion/accordion.component.ts</strong></em> replace:</li>
</ol>
<pre><code class="language-ts">import '@potato/ace/components/accordion/accordion';
</code></pre>
<p>with</p>
<pre><code class="language-ts">require('@potato/ace/components/accordion/accordion.js');
</code></pre>
<h2 id="ace-with-vue">ACE with Vue</h2>
<p>The following examples shows how ACE components can be used with Vue (v3+). More general information about how to use custom elements with Vue can be found in the <a href="https://v3.vuejs.org/guide/web-components.html#skipping-component-resolution">Vue web components guide</a>.</p>
<p>These examples demonstrate how to use an ACE Accordion, pass data to it from a parent component via <code>props</code>, use the <code>created</code> &amp; <code>unmounted</code> lifecycle hooks in the parent to listen for a custom event dispatched by Accordion, and interact with Accordion from the parent using a custom event.</p>
<h3 id="vue-without-typescript">Vue without TypeScript</h3>
<p>Starting with a fresh Vue project that does not use TypeScript, created using Vue CLI command <code>vue create</code>:</p>
<ol>
<li>Install ACE:</li>
</ol>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<ol start="2">
<li>Create file <code>vue.config.js</code> with following content:</li>
</ol>
<pre><code class="language-js">module.exports = {
  chainWebpack: config =&gt; {
    config.module
      .rule('vue')
      .use('vue-loader')
      .tap(options =&gt; ({
        ...options,
        compilerOptions: {
          // treat any tag that starts with ace- as custom elements
          isCustomElement: tag =&gt; tag.startsWith('ace-')
        }
      }))
  }
}
</code></pre>
<ol start="3">
<li>Replace the contents of <em><strong>src/App.vue</strong></em> with:</li>
</ol>
<pre><code class="language-html">&lt;template&gt;
  &lt;Accordion :content=&quot;accordionContent&quot; :id=&quot;id&quot; /&gt;
  &lt;button :disabled=&quot;panelsCollapsed&quot; @click=&quot;collapseAll&quot;&gt;
    Collapse all
  &lt;/button&gt;
&lt;/template&gt;

&lt;script&gt;
  import Accordion from './components/Accordion.vue';
  import {ATTRS, EVENTS} from '@potato/ace/components/accordion/accordion';

  export default {
    name: 'App',
    components: {
      Accordion
    },
    data() {
      return {
        accordionContent: [
          {
            content: 'Panel 1 content',
            trigger: 'Panel 1 trigger',
          },
          {
            content: 'Panel 2 content',
            trigger: 'Panel 2 trigger',
          },
        ],
        id: 'ace-accordion',
        panelsCollapsed: true,
      }
    },
    created () {
      window.addEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, this.onPanelChange);
    },
    unmounted () {
      window.removeEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, this.onPanelChange);
    },
    methods: {
      collapseAll() {
        window.dispatchEvent(new CustomEvent(
          EVENTS.IN.HIDE_ALL_PANELS,
          {'detail': {'id': this.id}},
        ));
      },
      onPanelChange() {
        this.panelsCollapsed = document.querySelectorAll(`[${ATTRS.PANEL_VISIBLE}]`).length === 0;
      },
    },
  }
&lt;/script&gt;
</code></pre>
<ol start="4">
<li>Rename <em><strong>src/components/HelloWorld.vue</strong></em> as <code>Accordion.vue</code> and replace the contents with:</li>
</ol>
<pre><code class="language-html">&lt;template&gt;
	&lt;ace-accordion&gt;
		&lt;template v-for=&quot;(panel, index) of content&quot; :key=&quot;index&quot;&gt;
			&lt;h3&gt;
				&lt;button&gt;{{panel.trigger}}&lt;/button&gt;
			&lt;/h3&gt;
			&lt;div&gt;
				&lt;p&gt;{{panel.content}}&lt;/p&gt;
			&lt;/div&gt;
		&lt;/template&gt;
	&lt;/ace-accordion&gt;
&lt;/template&gt;

&lt;script&gt;
	export default {
		name: 'Accordion',
		props: {
			content: Array
		},
	}
&lt;/script&gt;

&lt;style&gt;
	@import '~@potato/ace/components/accordion/ace-accordion.css';
&lt;/style&gt;
</code></pre>
<h3 id="vue-with-typescript">Vue with TypeScript</h3>
<p>Starting with a fresh Vue TypeScript project, created using Vue CLI command <code>vue create</code>:</p>
<ol>
<li>Install ACE:</li>
</ol>
<pre><code class="language-bash">npm i @potato/ace
</code></pre>
<ol start="2">
<li>Create file <code>vue.config.js</code> with following content:</li>
</ol>
<pre><code class="language-js">module.exports = {
  chainWebpack: config =&gt; {
    config.module
      .rule('vue')
      .use('vue-loader')
      .tap(options =&gt; ({
        ...options,
        compilerOptions: {
          // treat any tag that starts with ace- as custom elements
          isCustomElement: tag =&gt; tag.startsWith('ace-')
        }
      }))
  }
}
</code></pre>
<ol start="3">
<li>Replace the contents of <em><strong>src/App.vue</strong></em> with:</li>
</ol>
<pre><code class="language-html">&lt;template&gt;
  &lt;Accordion :content=&quot;accordionContent&quot; :id=&quot;id&quot; /&gt;
  &lt;button :disabled=&quot;panelsCollapsed&quot; @click=&quot;collapseAll&quot;&gt;
    Collapse all
  &lt;/button&gt;
&lt;/template&gt;

&lt;script lang=&quot;ts&quot;&gt;
  import {defineComponent} from 'vue';
  import Accordion from './components/Accordion.vue';
  import {ATTRS, EVENTS} from '@potato/ace/components/accordion/accordion';

  export default defineComponent({
    name: 'App',
    components: {
      Accordion
    },
    data() {
      return {
        accordionContent: [
          {
            content: 'Panel 1 content',
            trigger: 'Panel 1 trigger',
          },
          {
            content: 'Panel 2 content',
            trigger: 'Panel 2 trigger',
          },
        ],
        id: 'ace-accordion',
        panelsCollapsed: true,
      }
    },
    created () {
      window.addEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, this.onPanelChange);
    },
    unmounted () {
      window.removeEventListener(EVENTS.OUT.PANEL_VISIBILITY_CHANGED, this.onPanelChange);
    },
    methods: {
      collapseAll() {
        window.dispatchEvent(new CustomEvent(
          EVENTS.IN.HIDE_ALL_PANELS,
          {'detail': {'id': this.id}},
        ));
      },
      onPanelChange() {
        this.panelsCollapsed = document.querySelectorAll(`[${ATTRS.PANEL_VISIBLE}]`).length === 0;
      },
    },
  });
&lt;/script&gt;

</code></pre>
<ol start="4">
<li>Rename <em><strong>src/components/HelloWorld.vue</strong></em> as <code>Accordion.vue</code> and replace the contents with:</li>
</ol>
<pre><code class="language-html">&lt;template&gt;
	&lt;ace-accordion&gt;
		&lt;template v-for=&quot;(panel, index) of content&quot; :key=&quot;index&quot;&gt;
			&lt;h3&gt;
				&lt;button&gt;{{panel.trigger}}&lt;/button&gt;
			&lt;/h3&gt;
			&lt;div&gt;
				&lt;p&gt;{{panel.content}}&lt;/p&gt;
			&lt;/div&gt;
		&lt;/template&gt;
	&lt;/ace-accordion&gt;
&lt;/template&gt;

&lt;script lang=&quot;ts&quot;&gt;
	import {defineComponent} from 'vue';

	export default defineComponent({
		name: 'Accordion',
		props: {
			content: Array
		},
	})
&lt;/script&gt;

&lt;style&gt;
	@import '~@potato/ace/components/accordion/ace-accordion.css';
&lt;/style&gt;
</code></pre>
